=== libretro-ffmpeg/Makefile ===
LIBRETRO_SWITCH        = 0

INTERNAL_LIBAVCODEC    = 0
INTERNAL_LIBAVFORMAT   = 0
INTERNAL_LIBAVUTIL     = 0
INTERNAL_LIBSWRESAMPLE = 0
INTERNAL_LIBSWSCALE    = 0

INTERNAL_LIBFLAC       = 0
INTERNAL_LIBOGG        = 0
INTERNAL_LIBLAME       = 0
INTERNAL_LIBFAAC       = 0
INTERNAL_LIBSPEEX      = 0
INTERNAL_LIBTHEORA     = 0
INTERNAL_LIBOPUS       = 0  
INTERNAL_LIBVORBIS     = 0
INTERNAL_WEBP          = 0
INTERNAL_ZLIB          = 0
INTERNAL_WAVPACK       = 0
INTERNAL_XVIDCORE      = 0
INTERNAL_VPX           = 0


BAKE_IN_FFMPEG := 0

#CPU Optimization flags
HAVE_SSE2 = 0
HAVE_MMX = 0
HAVE_THREADS = 1

#Additional codec support for internal FFmpeg
HAVE_WAVPACK   = 0
HAVE_LIBSPEEX  = 0
HAVE_LIBWEBP   = 0
HAVE_LIBOGG    = 0
HAVE_LIBX264   = 0
HAVE_LIBX265   = 0
HAVE_LIBFAAC   = 0
HAVE_LIBFLAC   = 0
HAVE_LIBLAME   = 0
HAVE_LIBTWOLAME = 0
HAVE_LIBVORBIS = 0
HAVE_LIBTHEORA = 0
HAVE_LIBOPUS   = 0
HAVE_ZLIB      = 0

#Video support
OPENGL = 1
HAVE_CODEC_HW = 0

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

system = $(shell uname -m)

ifeq ($(system),x86_64)
ARCH_X86 = 1
ARCH_X86_64 = 1
endif

TARGET_NAME := ffmpeg

ifneq (,$(findstring unix,$(platform)))
	ARCH_X86 = 1
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined -fPIC
ifeq ($(OPENGL),1)
   GL_LIB := -lGL
   CFLAGS += -DHAVE_OPENGL
   HAVE_GL := 1
	HAVE_GL_FFT := 1
endif
   HAVE_SSA := 1

   LIBS = $(shell pkg-config libass --libs) -pthread
   CFLAGS += $(shell pkg-config libass --cflags) -pthread
	CFLAGS += -DHAVE_STRUCT_SOCKADDR_STORAGE -DHAVE_STRUCT_ADDRINFO -DHAVE_FMINF
	HAVE_POLL_H = 1
	HAVE_GETADDRINFO = 1
	HAVE_NETWORK = 1
	HAVE_SOCKLEN = 1
	HAVE_PTHREADS = 1
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += $(shell pkg-config libavcodec --libs)
   CFLAGS += $(shell pkg-config libavcodec --cflags)
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += $(shell pkg-config libavformat --libs)
   CFLAGS += $(shell pkg-config libavformat --cflags)
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += $(shell pkg-config libswresample --libs)
   CFLAGS += $(shell pkg-config libswresample --cflags)
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += $(shell pkg-config libavutil --libs)
   CFLAGS += $(shell pkg-config libavutil --cflags)
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
   LIBS += $(shell pkg-config libswscale --libs)
   CFLAGS += $(shell pkg-config libswscale --cflags)
endif
else ifneq (,$(findstring osx,$(platform)))
	ARCH_X86 = 1
   LIBRETRO_SWITCH = 1
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   CFLAGS += -I. -I.. -DHAVE_FMINF
ifeq ($(OPENGL),1)
   GL_LIB := -framework OpenGL
   HAVE_GL := 1
   HAVE_GL_FFT := 1
   CFLAGS += -DHAVE_GL
endif
HAVE_PTHREADS = 1
   OSXVER = `sw_vers -productVersion | cut -d. -f 2`
   OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
   fpic += -mmacosx-version-min=10.1
	CFLAGS += -DHAVE_STRUCT_SOCKADDR_STORAGE -DHAVE_STRUCT_ADDRINFO
	HAVE_POLL_H = 1
	HAVE_GETADDRINFO = 1
	HAVE_NETWORK = 1
	HAVE_SOCKLEN = 1

   LIBS = $(shell pkg-config libass --libs) -pthread
   CFLAGS += $(shell pkg-config libass --cflags) -pthread
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += $(shell pkg-config libavcodec --libs)
   CFLAGS += $(shell pkg-config libavcodec --cflags)
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += $(shell pkg-config libavformat --libs)
   CFLAGS += $(shell pkg-config libavformat --cflags)
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += $(shell pkg-config libswresample --libs)
   CFLAGS += $(shell pkg-config libswresample --cflags)
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += $(shell pkg-config libavutil --libs)
   CFLAGS += $(shell pkg-config libavutil --cflags)
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
   LIBS += $(shell pkg-config libswscale --libs)
   CFLAGS += $(shell pkg-config libswscale --cflags)
endif
else ifneq (,$(findstring win,$(platform)))
	ARCH_X86 = 1
   CC = gcc
	CXX = g++
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -Iffmpeg
ifeq ($(OPENGL),1)
   GL_LIB := -lopengl32
   CFLAGS += -DHAVE_OPENGL
   HAVE_GL := 1
	HAVE_GL_FFT := 1
	WIN32_PLATFORM := 1
endif
   LIBS += -L.
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += -lavcodec
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += -lavformat
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += -lswresample
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += -lavutil
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
	LIBS += -lswscale
endif
endif

ifeq ($(LIBRETRO_SWITCH),1)
CFLAGS += -DLIBRETRO_SWITCH=1
INTERNAL_LIBAVCODEC    = 1
INTERNAL_LIBAVFORMAT   = 1
INTERNAL_LIBAVUTIL     = 1
INTERNAL_LIBSWRESAMPLE = 1
INTERNAL_LIBSWSCALE    = 1

INTERNAL_LIBFLAC       = 1
INTERNAL_LIBOGG        = 1
INTERNAL_LIBLAME       = 1
INTERNAL_LIBFAAC       = 1
INTERNAL_LIBVORBIS     = 1
INTERNAL_ZLIB          = 1
endif

ifeq ($(INTERNAL_LIBAVCODEC),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBAVFORMAT),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBSWRESAMPLE),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBWSCALE),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBAVUTIL),1)
	BAKE_IN_FFMPEG += 1
endif

CFLAGS += -D__LIBRETRO__

ifeq ($(HAVE_SSA), 1)
   LIBS += $(shell pkg-config libass --libs)
   CFLAGS += -DHAVE_SSA
endif

LIBRETROCOMM_DIR := ../../libretro-common
DEPS_DIR         := ../../deps

LIBAVCODEC_SOURCE :=
LIBAVFORMAT_SOURCE :=
LIBAVUTIL_SOURCE :=
LIBRETRO_SOURCE := ffmpeg_core.c \
						 $(LIBRETROCOMM_DIR)/queues/fifo_queue.c \
						 $(LIBRETROCOMM_DIR)/rthreads/rthreads.c
DEPS_SOURCE :=

ifeq ($(HAVE_BIGENDIAN),1)
CPUOPTS += -DHAVE_BIGENDIAN=1
else
CPUOPTS += -DHAVE_BIGENDIAN=0
endif

ifneq ($(BAKE_IN_FFMPEG),0)

ifeq ($(INTERNAL_LIBAVCODEC),1)

ifeq ($(INTERNAL_ZLIB),0)
	LIBS += -lz
	HAVE_ZLIB = 1
else
	HAVE_ZLIB = 1
	DEPS_SOURCE += $(wildcard libz/*.c)
endif

ifeq ($(INTERNAL_LIBFLAC),0)
	LIBS += -lFLAC
	HAVE_LIBFLAC = 1
else
	CFLAGS += -I. -IlibFLAC -IlibFLAC/include -DHAVE_LROUND
	HAVE_LIBFLAC = 1
	DEPS_SOURCE += $(wildcard libFLAC/*.c)
endif

ifeq ($(INTERNAL_LIBOPUS),0)
	#LIBS += -lopus
	#HAVE_LIBOPUS = 1
else
	#CFLAGS += -I. -Ilibopus -Ilibopus/celt -DUSE_ALLOCA -DOPUS_BUILD
	#HAVE_LIBOPUS = 1
	#DEPS_SOURCE += $(wildcard libopus/*.c) $(wildcard libopus/celt/*.c)
endif

ifeq ($(INTERNAL_LIBVORBIS),0)
	LIBS += -lvorbis -lvorbisenc -lvorbisfile
	HAVE_LIBVORBIS = 1
else
	CFLAGS += -DOV_EXCLUDE_STATIC_CALLBACKS -Ivorbis
	HAVE_LIBVORBIS = 1
	DEPS_SOURCE += $(wildcard vorbis/*.c)
endif

ifeq ($(INTERNAL_LIBLAME),0)
	LIBS += -lmp3lame
	HAVE_LIBLAME = 1
else
	HAVE_LIBLAME = 1
	CFLAGS += -Ilibmp3lame
	DEPS_SOURCE += $(wildcard libmp3lame/*.c)
endif

ifeq ($(INTERNAL_LIBSPEEX),0)
	LIBS += -lspeex
	HAVE_LIBSPEEX = 1
endif

ifeq ($(INTERNAL_WEBP),0)
	LIBS += -lwebp
	HAVE_LIBWEBP = 1
endif

ifeq ($(INTERNAL_LIBOGG),0)
	LIBS += -logg
	HAVE_LIBOGG = 1
else
	CFLAGS += -DOV_EXCLUDE_STATIC_CALLBACKS
	HAVE_LIBOGG = 1
	DEPS_SOURCE += ogg/bitwise.c ogg/framing.c
endif

ifeq ($(INTERNAL_LIBFAAC),0)
	LIBS += -lfaac
	HAVE_LIBFAAC = 1
else
	CFLAGS += -Ilibfaac
	HAVE_LIBFAAC = 1
	DEPS_SOURCE += $(wildcard libfaac/*.c)
endif

ifeq ($(INTERNAL_WAVPACK),0)
	LIBS += -lwavpack
	HAVE_WAVPACK = 1
endif

ifeq ($(INTERNAL_XVIDCORE),0)
   LIBS += -lxvidcore
endif

ifeq ($(INTERNAL_LIBTHEORA),0)
	LIBS += -ltheora -ltheoraenc -ltheoradec
	HAVE_LIBTHEORA = 1
endif

ifeq ($(INTERNAL_VPX),0)
	LIBS += -lvpx
	HAVE_VPX = 1
endif

endif

LIBS += -lm

CFLAGS += -DCONFIG_SMALL=0

## CPU Flags

#Blackfin DSP. Pretty sure we won't target this for libretro (if ever).

CPUOPTS += -DARCH_BFIN=0

#We can reasonably assume MMX will be there on all x86 CPUs from 1997 and up at least
#SSE2 can be assumed from Pentium 4 and up - can be switched on or off with the switch HAVE_SSE2

CPUOPTS += -DHAVE_AMD3DNOW_INLINE=0
CPUOPTS += -DHAVE_AMD3DNOWEXT_EXTERNAL=0

ifeq ($(ARCH_X86),1)
CPUOPTS += -DARCH_X86=1
ifneq ($(ARCH_X86_64),1)
CPUOPTS += -DARCH_X86_32=1
endif
CPUOPTS += -DHAVE_MMX2=0
CPUOPTS += -DHAVE_EBX_AVAILABLE=1
CPUOPTS += -DHAVE_EBP_AVAILABLE=1
ifeq ($(HAVE_MMX), 1)
CPUOPTS += -DHAVE_MMX=1
CPUOPTS += -DHAVE_MMXEXT=1
CPUOPTS += -DHAVE_MMX_EXTERNAL=1
CPUOPTS += -DHAVE_MMXEXT_EXTERNAL=1
CPUOPTS += -DHAVE_AMD3DNOW_EXTERNAL=0
CPUOPTS += -DHAVE_MMX_INLINE=1 -DHAVE_MMXEXT_INLINE=0
else
CPUOPTS += -DHAVE_MMX=0
CPUOPTS += -DHAVE_MMXEXT=0
CPUOPTS += -DHAVE_MMX_EXTERNAL=0
CPUOPTS += -DHAVE_MMXEXT_EXTERNAL=0
CPUOPTS += -DHAVE_AMD3DNOW_EXTERNAL=0
CPUOPTS += -DHAVE_XOP_EXTERNAL=0
CPUOPTS += -DHAVE_MMX_INLINE=0 -DHAVE_MMXEXT_INLINE=0
endif
CPUOPTS += -DHAVE_ALIGNED_STACK -DHAVE_FAST_UNALIGNED=0

ifeq ($(HAVE_SSE1),1)
CPUOPTS += -DHAVE_SSE=1
CPUOPTS += -DHAVE_SSE_EXTERNAL=1
else
CPUOPTS += -DHAVE_SSE=0
CPUOPTS += -DHAVE_SSE_EXTERNAL=0
endif

ifeq ($(HAVE_SSE2),1)
CPUOPTS += -DHAVE_SSE2=1
CPUOPTS += -DHAVE_SSE2_EXTERNAL=1
CPUOPTS += -DHAVE_SSE2_INLINE=1

else
CPUOPTS += -DHAVE_SSE2=0
CPUOPTS += -DHAVE_SSE2_EXTERNAL=0
CPUOPTS += -DHAVE_SSE2_INLINE=0

endif

CPUOPTS += -DHAVE_FMA3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE4_EXTERNAL=0
CPUOPTS += -DHAVE_SSE42_EXTERNAL=0
CPUOPTS += -DHAVE_AVX_EXTERNAL=0
CPUOPTS += -DHAVE_AVX2_EXTERNAL=0
else
CPUOPTS += -DHAVE_FMA3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE_EXTERNAL=0
CPUOPTS += -DHAVE_SSE2_INLINE=0
CPUOPTS += -DHAVE_SSE2_EXTERNAL=0
CPUOPTS += -DHAVE_SSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE4_EXTERNAL=0
CPUOPTS += -DHAVE_SSE42_EXTERNAL=0
CPUOPTS += -DHAVE_AVX_EXTERNAL=0
CPUOPTS += -DHAVE_AVX2_EXTERNAL=0
endif

ifeq ($(ARCH_X86_64),1)
CPUOPTS += -DARCH_X86_64=1
CPUOPTS += -DARCH_X86_32=0
CFLAGS += -DHAVE_FAST_64BIT=1
else
CPUOPTS += -DARCH_X86_64=0
CFLAGS += -DHAVE_FAST_64BIT=0
endif

#This is ARMv8/NEON
ifeq ($(ARCH_AARCH64),1)
CPUOPTS += -DARCH_AARCH64=1
else
CPUOPTS += -DARCH_AARCH64=0
endif

ifeq ($(ARCH_ARM),1)
CPUOPTS += -DARCH_ARM=1
else
CPUOPTS += -DARCH_ARM=0
endif
ifeq ($(ARCH_PPC),1)
CPUOPTS += -DARCH_PPC=1
else
CPUOPTS += -DARCH_PPC=0
endif

ifeq ($(HAVE_ALTIVEC),1)
CPUOPTS += -DHAVE_ALTIVEC=1
else
CPUOPTS += -DHAVE_ALTIVEC=0
endif

ifeq ($(ARCH_MIPS),1)
# Not sure if we can just define this for all MIPS archs - probably not
CPUOPTS += -DHAVE_MIPSFPU=1
CPUOPTS += -DARCH_MIPS=1
CPUOPTS += -DHAVE_MIPSDSPR1=0
else
CPUOPTS += -DHAVE_MIPSFPU=0
CPUOPTS += -DARCH_MIPS=0
CPUOPTS += -DHAVE_MIPSDSPR1=0
endif

ifeq ($(ARCH_ALPHA),1)
CPUOPTS += -DARCH_ALPHA=1
else
CPUOPTS += -DARCH_ALPHA=0
endif

CFLAGS += -I$(BASE_DIR) -I. -DHAVE_CBRT -DHAVE_CBRTF -DHAVE_ISINF -DHAVE_ISNAN -DHAVE_RINT -DHAVE_LRINT -DHAVE_LRINTF -DHAVE_ROUND -DHAVE_ROUNDF -DHAVE_TRUNC -DHAVE_TRUNCF -DHAVE_YASM=0 $(CPUOPTS)

ifeq ($(HAVE_POLL_H),1)
CFLAGS += -DHAVE_POLL_H
endif

ifeq ($(HAVE_SOCKLEN),1)
CFLAGS += -DHAVE_SOCKLEN_T
endif

ifeq ($(HAVE_GETADDRINFO),1)
CFLAGS += -DHAVE_GETADDRINFO=1
endif

ifeq ($(HAVE_NETWORK),1)
CFLAGS += -DCONFIG_NETWORK=1
endif

# Threading flags

ifeq ($(HAVE_THREADS),1)
CFLAGS += -DHAVE_THREADS=1

ifeq ($(ARCH_X86),1)
CFLAGS += -DHAVE_ATOMICS_GCC=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(ARCH_X86_64),1)
CFLAGS += -DHAVE_ATOMICS_GCC=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(WIN32_PLATFORM),1)
CFLAGS += HAVE_ATOMICS_WIN32=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(HAVE_PTHREADS),1)
CFLAGS += -DHAVE_PTHREADS=1
endif

else
CFLAGS += -DHAVE_THREADS=0
CFLAGS += -DHAVE_PTHREADS=0
endif

ifeq ($(HAVE_LIBLAME),1)
CFLAGS += -DCONFIG_LIBMP3LAME=1 \
			 -DCONFIG_LIBMP3LAME_ENCODER=1
else
CFLAGS += -DCONFIG_LIBMP3LAME=0 \
			 -DCONFIG_LIBMP3LAME_ENCODER=0
endif

ifeq ($(HAVE_LIBVORBIS),1)
CFLAGS += -DCONFIG_LIBVORBIS=1 \
			 -DCONFIG_VORBIS_ENCODER=1 \
			 -DCONFIG_LIBVORBIS_ENCODER=1 \
