=== debian/changelog ===
retroarch (1.3.6+dfsg1-1) unstable; urgency=low

  * New upstream release.
  * Changed package maintainer to Debian Games Team.
  * Fixed hardening-no-bindnow, hardening-no-pie.
  * Fixed hardening-no-fortify-functions (CPPFLAGS patch).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Tue, 23 Aug 2016 22:44:00 -0300

retroarch (1.3.0+dfsg1-1) unstable; urgency=low

  * Removed Sony copyrighted files.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Tue, 17 May 2016 22:21:00 -0300

retroarch (1.3.0-2) unstable; urgency=low

  * Removed debug packages from control (automatic -dbgsym packages).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 10 Apr 2016 22:36:00 -0300

retroarch (1.3.0-1) unstable; urgency=low

  * Initial release (Closes: #792608).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 23 Mar 2016 22:55:00 -0300
